import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import classNames from 'classnames';
import React from 'react';
import warning from 'warning';
import { useUncontrolled } from 'uncontrollable';
import { useBootstrapPrefix } from './ThemeProvider';
import AbstractNav from './AbstractNav';
import ListGroupItemComp from './ListGroupItem';
var defaultProps = {
  variant: null,
  horizontal: null
};
export var ListGroup = function ListGroup(_ref) {
  var _ref$items = _ref.items,
      items = _ref$items === void 0 ? false : _ref$items,
      _ref$ListGroupItem = _ref.ListGroupItem,
      ListGroupItem = _ref$ListGroupItem === void 0 ? false : _ref$ListGroupItem;
  var $ListGroup = React.forwardRef(function (props, ref) {
    var _useUncontrolled = useUncontrolled(props, {
      activeKey: 'onSelect'
    }),
        className = _useUncontrolled.className,
        bsPrefix = _useUncontrolled.bsPrefix,
        variant = _useUncontrolled.variant,
        horizontal = _useUncontrolled.horizontal,
        _useUncontrolled$as = _useUncontrolled.as,
        as = _useUncontrolled$as === void 0 ? 'div' : _useUncontrolled$as,
        controlledProps = _objectWithoutPropertiesLoose(_useUncontrolled, ["className", "bsPrefix", "variant", "horizontal", "as"]);

    bsPrefix = useBootstrapPrefix(bsPrefix, 'list-group');
    var horizontalVariant;

    if (horizontal) {
      horizontalVariant = horizontal === true ? 'horizontal' : "horizontal-" + horizontal;
    } else {
      horizontalVariant = null;
    }

    process.env.NODE_ENV !== "production" ? warning(!(horizontal && variant === 'flush'), '`variant="flush"` and `horizontal` should not be used together.') : void 0;

    if (props.items && items) {
      controlledProps.children = items(props.items);
    }

    delete controlledProps.items;
    return /*#__PURE__*/React.createElement(AbstractNav, _extends({
      ref: ref
    }, controlledProps, {
      as: as,
      className: classNames(className, bsPrefix, variant && bsPrefix + "-" + variant, horizontalVariant && bsPrefix + "-" + horizontalVariant)
    }));
  });
  $ListGroup.defaultProps = defaultProps;
  $ListGroup.displayName = 'ListGroup';

  if (ListGroupItem) {
    $ListGroup.Item = ListGroupItem;
  }

  return $ListGroup;
};
export var items = function items(array) {
  return array.map(function (a) {
    var props = _extends({}, a);

    props.children = a.value;
    props.key = a.value;
    return /*#__PURE__*/React.createElement(ListGroupItemComp, props);
  });
};